oyCMMui_s Struct Reference
Description: C source code API documentation for the Oyranos project.
Keywords: Oyranos,Color Management,Color Management,ICC,CMS,C,doxygen,API,documentation

| Oyranos Color Management System API - Version 0.9.6

Public Types | Public Member Functions | Data Fields
oyCMMui_s Struct Reference
Backend Modules

The CMM API UI part. More...

`#include <oyCMMui_s.h>`

Inheritance diagram for oyCMMui_s:
Collaboration diagram for oyCMMui_s:

## Public Types
typedef int(* | oyCMMuiGet_f) (oyCMMapiFilter_s *module, oyOptions_s *options, char **ui_text, oyAlloc_f allocateFunc)
| obtain a XFORMS ui description More...

## Public Member Functions
OYAPI oyCMMui_s *OYEXPORT | oyCMMui_New (oyObject_s object)
| allocate a new CMMui object More...
| oyCMMui_Copy
| Copy or Reference a CMMui object. More...
OYAPI int OYEXPORT | oyCMMui_Release (oyCMMui_s **cmmui)
| release and possibly deallocate a oyCMMui_s object More...
OYAPI oyCMMui_s *OYEXPORT | oyCMMui_Create (const char *category, oyCMMGetText_f getText, const char **texts, oyObject_s object)
| Create a oyCMMui_s object. More...
OYAPI void OYEXPORT | oyCMMui_SetUiOptions (oyCMMui_s *ui, const char *options, oyCMMuiGet_f oyCMMuiGet)
| Set UI for possible options. More...
oyCMMGetText_f | oyCMMui_GetTextF (oyCMMui_s *ui)
| Get the GetText function. More...
const char ** | oyCMMui_GetTexts (oyCMMui_s *ui)
| Get texts for GetTextF. More...
oyCMMapiFilter_s * | oyCMMui_GetParent (oyCMMui_s *ui)
| Get the parent structure. More...
Public Member Functions inherited from oyStruct_s
const char * | oyStruct_GetTextFromModule (oyStruct_s *obj, oyNAME_e name_type, uint32_t flags)
| get object infos from a module More...
const char * | oyStruct_GetText (oyStruct_s *obj, oyNAME_e name_type, uint32_t flags)
| Get a text dump. More...
| oyStruct_RegisterStaticMessageFunc
| register a function for verbosity More...
| oyStruct_GetInfo
| get a additional string from a object More...
const char * | oyStructTypeToText (oyOBJECT_e type)
| Objects type to small string. More...

## Data Fields
const oyOBJECT_e | type_
| Type of object. More...
oyStruct_Copy_f | copy
| Copy function. More...
oyStruct_Release_f | release
| Release function. More...
oyObject_s | oy_
| Oyranos internal object. More...
Data Fields inherited from oyStruct_s
const oyOBJECT_e | type_
| Type of object. More...
oyStruct_Copy_f | copy
| Copy function. More...
oyStruct_Release_f | release
| Release function. More...
oyObject_s | oy_
| Oyranos internal object. More...

## Detailed Description

The CMM API UI part.

Examples:
  oyranos_cmm_oJPG.c.

## Member Function Documentation

## ◆ oyCMMui_Copy()

oyCMMui_Copy

Copy or Reference a CMMui object.

The function is for copying and for referencing. The reference is the most often used way, which saves resourcs and time.

Parameters

  [in] | cmmui | CMMui struct object
  | object | NULL - means reference, the optional object triggers a real copy

## ◆ oyCMMui_Create()

OYAPI oyCMMui_s *OYEXPORT oyCMMui_Create | ( | const char * | category,
|  | oyCMMGetText_f | getText,
|  | const char ** | texts,
|  | oyObject_s | object
| ) |  |

Create a oyCMMui_s object.

Function oyCMMui_Create

Parameters

  category | menu structure
  getText | translated UI texts
  texts | zero terminated list of string classes for getText, e.g. {"name","category","help",0} The "name" texts shall include information about the module. The oyNAME_NICK for the several oyCMMui_s::getText() texts is typical not translated. For "name" the oyNAME_NICK should be the module name. The "category" gives in oyNAME_NAME a translated version of oyCMMui_s::category. The "help" texts should provide general infromations about the module. For other texts like "help" and "category" oyNAME_NICK makes no sense.
  object | optional object

Returns
  the struct

See also
  oyCMMui_GetTextF() oyCMMui_GetTexts()

Version
  Oyranos: 0.9.5

Date
  2013/06/11

Since
  2013/06/11 (Oyranos: 0.9.5)

Examples:
  oyranos_cmm_oJPG.c.

References oyCMMui_New().

## ◆ oyCMMui_GetParent()

oyCMMapiFilter_s * oyCMMui_GetParent | ( | oyCMMui_s * | ui | ) |

Get the parent structure.

Parameters

  [in] | ui | ui object

Returns
  the parent object

Version
  Oyranos: 0.9.5

Date
  2014/01/07

Since
  2014/01/07 (Oyranos: 0.9.5)

Examples:
  oyranos_cmm_oJPG.c.

References oyCMMapiFilter_s::copy.

## ◆ oyCMMui_GetTextF()

oyCMMGetText_f oyCMMui_GetTextF | ( | oyCMMui_s * | ui | ) |

Get the GetText function.

Function oyCMMui_GetTextF

Parameters

  [in] | ui | ui object

Returns
  the oyCMMGetText_f function

Version
  Oyranos: 0.5.0

Date
  2012/09/15

Since
  2012/09/15 (Oyranos: 0.5.0)

## ◆ oyCMMui_GetTexts()

const char ** oyCMMui_GetTexts | ( | oyCMMui_s * | ui | ) |

Get texts for GetTextF.

Function oyCMMui_GetTexts

Parameters

  [in] | ui | ui object

Returns
  the zero terminated string list

zero terminated categories for getText, e.g. {"name","category","help",0}

The "name" texts shall include information about the module. The "category" gives in oyNAME_NAME a translated version of oyCMMui_s::category. The "help" texts should provide general infromations about the module.

The oyNAME_NICK for the several oyCMMui_s::getText() texts is typical not translated. For "name" the oyNAME_NICK should be the module name. For other texts like "help" and "category" oyNAME_NICK makes no sense.

Version
  Oyranos: 0.5.0

Date
  2012/09/15

Since
  2012/09/15 (Oyranos: 0.5.0)

## ◆ oyCMMui_New()

OYAPI oyCMMui_s *OYEXPORT oyCMMui_New | ( | oyObject_s | object | ) |

allocate a new CMMui object

Function oyCMMui_New

References oyOBJECT_OBJECT_S.

Referenced by oyCMMui_Create().

## ◆ oyCMMui_Release()

OYAPI int OYEXPORT oyCMMui_Release | ( | oyCMMui_s ** | cmmui | ) |

release and possibly deallocate a oyCMMui_s object

Function oyCMMui_Release

Parameters

  [in,out] | cmmui | CMMui struct object

References oyOBJECT_CMM_UI_S.

## ◆ oyCMMui_SetUiOptions()

OYAPI void OYEXPORT oyCMMui_SetUiOptions | ( | oyCMMui_s * | ui,
|  | const char * | options,
|  | oyCMMuiGet_f | oyCMMuiGet
| ) |  |

Set UI for possible options.

Function oyCMMui_SetUiOptions

Parameters

  [in] | ui | ui object
  | options | the default options as oFORMS model compatible XML
  | oyCMMuiGet | the oFORMS UI for filter options

Version
  Oyranos: 0.9.5

Date
  2013/06/13

Since
  2013/06/13 (Oyranos: 0.9.5)

Examples:
  oyranos_cmm_oJPG.c.

References oyOBJECT_CMM_UI_S.

## Field Documentation

## ◆ copy

oyStruct_Copy_f oyCMMui_s::copy

Copy function.

## ◆ oy_

oyObject_s oyCMMui_s::oy_

Oyranos internal object.

Features name and hash. Do not change during object life time.

## ◆ release

oyStruct_Release_f oyCMMui_s::release

Release function.

## ◆ type_

const oyOBJECT_e oyCMMui_s::type_

Type of object.

The struct type tells Oyranos how to interprete hidden fields.